//초음파센서로 장애물 피해가는 로봇
//바퀴 위치 및 회전방향에 따른 핀번호(~PWM) 변수 설정
int wheelLeftFront = 9, wheelLeftBack = 10;
int wheelRightFront = 5, wheelRightBack = 6;
int spdL = 200, spdR = 200; //속도 값

int trig = 2, echo = 3; //초음파센서 설정

void setup() {
  Serial.begin(9600);
  pinMode(trig, OUTPUT);
  pinMode(echo, INPUT);
  pinMode(wheelLeftFront, OUTPUT);
  pinMode(wheelLeftBack, OUTPUT);
  pinMode(wheelRightFront, OUTPUT);
  pinMode(wheelRightBack, OUTPUT);
}

void loop() {
  //초음파센서 거리 측정 및 시리얼모니터 출력
  float distance, duration;
  digitalWrite(trig, HIGH);
  delay(1);
  digitalWrite(trig, LOW);
  duration = pulseIn(echo, HIGH);
  distance = ((float)(340 * duration) / 10000) / 2;
  Serial.println(distance);
  
  //로봇동작
  if(distance > 15){
    //장애물 15cm 이내에 없을 경우 전진
    analogWrite(wheelLeftFront, spdL);
    analogWrite(wheelLeftBack, 0);
    analogWrite(wheelRightFront, spdR);
    analogWrite(wheelRightBack, 0);
  }else{
    //장애물 15cm 이내에 있을 경우 방향전환
    int rd = random(2); //좌,우 회전 랜덤 선택 (랜덤 값 : 0, 1)
    int delayrd = random(200, 500); // 회전 반경, 반환 값 : 200 ~ 500
    if(rd == 1){
      //좌회전
      analogWrite(wheelLeftFront, 0);
      analogWrite(wheelLeftBack, spdL);
      analogWrite(wheelRightFront, spdR);
      analogWrite(wheelRightBack, 0);
    }else{
      //우회전
      analogWrite(wheelLeftFront, spdL);
      analogWrite(wheelLeftBack, 0);
      analogWrite(wheelRightFront, 0);
      analogWrite(wheelRightBack, spdR);
    }
    delay(delayrd);
  }
}



